package com.zhiqiyun.open.mvc.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zhiqiyun.open.annotation.Permission;
import com.zhiqiyun.open.core.models.place.PlaceCategory;
import com.zhiqiyun.open.core.models.user.OauthInfo;
import com.zhiqiyun.open.core.service.PlaceCategoryService;
import com.zhiqiyun.open.core.service.OauthService;
import com.zhiqiyun.open.core.service.SequenceService;
import com.zhiqiyun.open.mvc.Result;
import com.zhiqiyun.open.mvc.params.place.QueryPlaceCategoryParam;
import com.zhiqiyun.open.mvc.params.place.SavePlaceCategoryParam;
import com.zhiqiyun.open.utils.DateUtil;
import com.zhiqiyun.open.utils.ServletContext;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping("/bz/data/type")
public class PlaceCategoryController {

    @Autowired
    private PlaceCategoryService placeCategoryService;

    @Autowired
    private SequenceService sequenceService;

    @Autowired
    private OauthService oauthService;

    @Permission(value = "place.category.find", tags = "查询文旅场所分类")
    @PostMapping("/findPage")
    public Result findPage(@RequestBody QueryPlaceCategoryParam param) {

        QueryWrapper<PlaceCategory> wrapper = new QueryWrapper<>();

        if (StringUtils.isNotBlank(param.getName())) {
            wrapper.like("name", param.getName());
        }
        Page<PlaceCategory> page = param.getPage();
        page.addOrder(OrderItem.asc("sort_number"));
        page.addOrder(OrderItem.desc("id"));

        Page<PlaceCategory> resultData = this.placeCategoryService.page(page, wrapper);

        return Result.instance(Result.Code.SUCCESS).setData(resultData);
    }

    @Permission(value = "place.category.add", tags = "新建文旅场所分类")
    @PostMapping("/save")
    public Result save(@Valid @RequestBody SavePlaceCategoryParam param) throws Exception {

        PlaceCategory entity = new PlaceCategory();
        BeanUtils.copyProperties(param, entity);

        OauthInfo oauthInfo = this.oauthService.getAuth(ServletContext.getAccessToken());

        if (param.getSortNumber() == null) {
            entity.setSortNumber(0);
        }

        entity.setCreatedTime(DateUtil.current());
        entity.setCreatedBy(oauthInfo.getId());

        entity.setUpdatedTime(DateUtil.current());
        entity.setUpdatedBy(oauthInfo.getId());
        entity.setId(this.sequenceService.nextId());

        this.placeCategoryService.save(entity);

        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }

    @Permission(value = "place.category.edit", tags = "更新文旅场所分类")
    @PostMapping("/updateById")
    public Result updateById(Long id, @Valid @RequestBody SavePlaceCategoryParam param) {
        PlaceCategory entity = new PlaceCategory();
        BeanUtils.copyProperties(param, entity);

        OauthInfo oauthInfo = this.oauthService.getAuth(ServletContext.getAccessToken());

        if (param.getSortNumber() == null) {
            entity.setSortNumber(0);
        }

        entity.setUpdatedBy(oauthInfo.getId());
        entity.setUpdatedTime(DateUtil.current());
        entity.setId(id);

        this.placeCategoryService.updateById(entity);

        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }

    @Permission(value = "place.category.delete", tags = "删除文旅场所分类")
    @PostMapping("/deleteByIds")
    public Result deleteByIds(@RequestBody List<Long> ids) {
        this.placeCategoryService.removeByIds(ids);
        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }
}
